class KCompletionBase

# class KCompletionBase | An abstract class for adding text completion support to widgets. More...
Contains pure virtuals
Definition | `#include <kcompletion.h>`
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum KeyBindingType { TextCompletion, /** }
- typedef QMap KeyBindingMap

#### Public Methods

- KCompletionBase ()
- virtual ~KCompletionBase ()
- KCompletion* completionObject ( bool hsig = true )
- virtual void setCompletionObject ( KCompletion* , bool hsig = true )
- virtual void setHandleSignals ( bool )
- bool isCompletionObjectAutoDeleted () const
- void setAutoDeleteCompletionObject ( bool autoDelete )
- void setEnableSignals ( bool enable )
- bool handleSignals () const
- bool emitSignals () const
- virtual void setCompletionMode ( KGlobalSettings::Completion mode )
- KGlobalSettings::Completion completionMode () const
- bool setKeyBinding ( KeyBindingType , const KShortcut& cut )
- const KShortcut& getKeyBinding ( KeyBindingType item ) const
- void useGlobalKeyBindings ()
- virtual void setCompletedText ( const QString& text )
- virtual void setCompletedItems ( const QStringList& items )
- KCompletion* compObj () const

#### Protected Methods

- KeyBindingMap getKeyBindings () const
- void setDelegate ( KCompletionBase *delegate )
- KCompletionBase * delegate () const
- virtual void virtual_hook ( int id, void* data )

## Detailed Description

An abstract base class for adding a completion feature into widgets.

This is a convenience class that provides the basic functions needed to add text completion support into widgets. All that is required is an implementation for the pure virtual function setCompletedText. Refer to KLineEdit or KComboBox to see how easily such support can be added using this as a base class.

enum KeyBindingType { TextCompletion, /** } | ### KeyBindingType

Text completion (by default Ctrl-E).

typedef QMap KShortcut> KeyBindingMap | ### KeyBindingMap

KCompletionBase () | ### KCompletionBase

Default constructor.

~KCompletionBase () | ### ~KCompletionBase

[virtual]

Destructor.

KCompletion* completionObject ( bool hsig = true ) | ### completionObject

Returns a pointer to the current completion object.

If the object does not exist, it is automatically created. Note that the completion object created here is used by default to handle the signals internally. It is also deleted when this object's destructor is invoked. If you do not want these default settings, use setAutoDeleteCompletionObject and setHandleSignals to change the behavior. Alternatively, you can set the boolean parameter to false to disable the automatic handling of the signals by this object. Note that the boolean argument will be ignored if there already exists a completion object since no new object needs to be created. You need to use either setHandleSignals or setCompletionObject for such cases depending on your requirement.

Parameters:

hsig | if true, handles signals internally.

Returns: a pointer the completion object.

void setCompletionObject ( KCompletion* , bool hsig = true ) | ### setCompletionObject

[virtual]

Sets up the completion object to be used.

This method assigns the completion object and sets it up to automatically handle the completion and rotation signals internally. You should use this function if you want to share one completion object among you widgets or need to use a customized completion object.

The object assigned through this method is not deleted when this object's destructor is invoked unless you explicitly call setAutoDeleteCompletionObject after calling this method. Also if you do not want the signals to be handled by an internal implementation, be sure to set the bool argument to false.

This method is also called when a completion-object is created automatically, when completionObject() is called the first time.

Parameters:

compObj | a KCompletion() or a derived child object.
hsig | if true, handles signals internally.

void setHandleSignals ( bool ) | ### setHandleSignals

[virtual]

Enables this object to handle completion and rotation events internally.

This function simply assigns a boolean value that indicates whether it should handle rotation and completion events or not. Note that this does not stop the object from emitting signals when these events occur.

Parameters:

handle | if true, handle completion & rotation internally.

bool isCompletionObjectAutoDeleted () | ### isCompletionObjectAutoDeleted

[const]

Returns true if the completion object is deleted upon this widget's destruction.

See setCompletionObject() and enableCompletion() for details.

Returns: true if the completion object will be deleted automatically

void setAutoDeleteCompletionObject ( bool autoDelete ) | ### setAutoDeleteCompletionObject

Sets the completion object when this widget's destructor is called.

If the argument is set to true, the completion object is deleted when this widget's destructor is called.

Parameters:

autoDelete | if true, delete completion object on destruction.

void setEnableSignals ( bool enable ) | ### setEnableSignals

Sets the widget's ability to emit text completion and rotation signals.

Invoking this function with `enable` set to `false` will cause the completion & rotation signals not to be emitted. However, unlike setting the completion object to `NULL` using setCompletionObject, disabling the emition of the signals through this method does not affect the current completion object.

There is no need to invoke this function by default. When a completion object is created through completionObject or setCompletionObject, these signals are set to emit automatically. Also note that disabling this signals will not necessarily interfere with the objects ability to handle these events internally. See setHandleSignals.

Parameters:

enable | if false, disables the emition of completion & rotation signals.

bool handleSignals () | ### handleSignals

[const]

Returns true if the object handles the signals.

Returns: true if this signals are handled internally.

bool emitSignals () | ### emitSignals

[const]

Returns true if the object emits the signals.

Returns: true if signals are emitted

void setCompletionMode ( KGlobalSettings::Completion mode ) | ### setCompletionMode

[virtual]

Sets the type of completion to be used.

The completion modes supported are those defined in KGlobalSettings(). See below.

- CompletionNone: Disables completion feature.
- CompletionAuto: Attempts to find a match & fills-in the remaining text.
- CompletionMan: Acts the same as the above except the action has to be manually triggered through pre-defined completion key.
- CompletionShell: Mimics the completion feature found in typical *nix shell environments.
- CompletionPopup: Shows all available completions at once, in a listbox popping up.

Parameters:

mode | Completion type:

KGlobalSettings::Completion completionMode () | ### completionMode

[const]

Returns the current completion mode.

The return values are of type KGlobalSettings::Completion. See setCompletionMode() for details.

Returns: the completion mode.

bool setKeyBinding ( KeyBindingType , const KShortcut& cut ) | ### setKeyBinding

Sets the key-binding to be used for manual text completion, text rotation in a history list as well as a completion list.

When the keys set by this function are pressed, a signal defined by the inheriting widget will be activated. If the default value or 0 is specified by the second parameter, then the key-binding as defined in the global setting should be used. This method returns false value for `key` is negative or the supplied key-binding conflicts with the ones set for one of the other features.

NOTE: To use a modifier key (Shift, Ctrl, Alt) as part of the key-binding simply simply `sum` up the values of the modifier and the actual key. For example, to use CTRL+E as a key binding for one of the items, you would simply supply @p "Qt::CtrlButton + Qt::Key_E" as the second argument to this function.

- TextCompletion the manual completion key-binding.
- PrevCompletionMatch the previous match key for multiple completion.
- NextCompletionMatch the next match key for for multiple completion.
- SubstringCompletion the key for substring completion

Parameters:

item | the feature whose key-binding needs to be set:
key | key-binding used to rotate down in a list.

Returns: true if key-binding can successfully be set.

See also: getKeyBinding

const KShortcut& getKeyBinding ( KeyBindingType item ) | ### getKeyBinding

[const]

Returns the key-binding used for the specified item.

This methods returns the key-binding used to activate the feature feature given by `item`. If the binding contains modifier key(s), the SUM of the modifier key and the actual key code are returned.

Parameters:

item | the item to check

Returns: the key-binding used for the feature given by `item`.

See also: setKeyBinding

void useGlobalKeyBindings () | ### useGlobalKeyBindings

Sets this object to use global values for key-bindings.

This method changes the values of the key bindings for rotation and completion features to the default values provided in KGlobalSettings.

NOTE: By default inheriting widgets should uses the global key-bindings so that there will be no need to call this method.

void setCompletedText ( const QString& text ) | ### setCompletedText

[pure virtual]

A pure virtual function that must be implemented by all inheriting classes.

This function is intended to allow external completion implementations to set completed text appropriately. It is mostly relevant when the completion mode is set to CompletionAuto and CompletionManual modes. See KCompletionBase::setCompletedText. Does nothing in CompletionPopup mode, as all available matches will be shown in the popup.

Parameters:

text | the completed text to be set in the widget.

void setCompletedItems ( const QStringList& items ) | ### setCompletedItems

[pure virtual]

A pure virtual function that must be implemented by all inheriting classes.

Parameters:

items | the list of completed items

KCompletion* compObj () | ### compObj

[const]

Returns a pointer to the completion object.

This method is only different from completionObject() in that it does not create a new KCompletion object even if the internal pointer is `NULL`. Use this method to get the pointer to a completion object when inheriting so that you won't inadvertently create it!!

Returns: the completion object or NULL if one does not exist.

KeyBindingMap getKeyBindings () | ### getKeyBindings

[protected const]

Returns a key-binding map.

This method is the same as getKeyBinding() except it returns the whole keymap containing the key-bindings.

Returns: the key-binding used for the feature given by `item`.

void setDelegate ( KCompletionBase *delegate ) | ### setDelegate

[protected]

Sets or removes the delegation object. If a delegation object is set, all function calls will be forwarded to the delegation object.

Parameters:

delegate | the delegation object, or 0 to remove it

KCompletionBase * delegate () | ### delegate

[protected const]

Returns the delegation object.

Returns: the delegation object, or 0 if there is none

See also: setDelegate()

void virtual_hook ( int id, void* data ) | ### virtual_hook

[protected virtual]

- Author: Dawit Alemayehu
- Generated: root on macppc.ports.openbsd.org on Sat Sep 6 10:36:15 2003, using kdoc 2.0a54.